/**
 * Diese Klasse definiert eine einfache Zeichnung. Um die Zeichnung auf
 * dem Bildschirm anzeigen zu lassen, muss die zeichne-Operation auf
 * einem Exemplar aufgerufen werden.
 * Aber hier steckt mehr drin: Da es eine elektronische Zeichnung ist,
 * kann sie gendert werden. Man kann sie schwarz-wei anzeigen lassen
 * und dann wieder in Farbe (nachdem sie gezeichnet wurde, ist ja klar).
 * 
 * Diese Klasse ist als frhes Java-Lehrbeispiel mit BlueJ gedacht.
 * 
 * @author  Michael Klling und David J. Barnes erweitert von A. Dietz (04.03.2007)
 * @version 1.0  (3. Januar 2003)
 */
public class Zeichnung
{
    private Quadrat wand;
    private Quadrat fenster;
    private Dreieck dach;
    private Kreis sonne;
    private Kreis zweiteSonne;
    

    /**
     * Erzeuge ein Exemplar der Klasse Zeichnung
     */
    public Zeichnung()
    {
        // nichts zu tun hier, alle Exemplarvariablen werden automatisch
        // mit null initialisiert.
    }

    /**
     * Zeichne die Zeichnung.
     */
    public void zeichne()
    {
        wand = new Quadrat();
        wand.setzePosition(60,130);
        wand.setzeSeitenlaenge(100);
        wand.sichtbarMachen();
        
        fenster = new Quadrat();
        fenster.farbeAendern("schwarz");
        fenster.setzePosition(80,150);
        fenster.setzeSeitenlaenge(30);
        fenster.sichtbarMachen();

        dach = new Dreieck();  
        dach.setzeBreite(140);
        dach.setzeHoehe(50);
        dach.setzePosition(110,85);
        dach.sichtbarMachen();

        sonne = new Kreis();
        sonne.farbeAendern("gelb");
        sonne.setzePosition(180,50);
        sonne.setzeDurchmesser(60);
        sonne.sichtbarMachen();
        
        zweiteSonne = new Kreis();
        zweiteSonne.farbeAendern("rot");
        zweiteSonne.setzePosition(250,50);
        zweiteSonne.setzeDurchmesser(40);
        zweiteSonne.sichtbarMachen();
        
    }

    /**
     * ndere die Darstellung in schwarz-wei.
     */
    public void inSchwarzWeissAendern()
    {
        if(wand != null)   // nur wenn schon gezeichnet wurde ...
        {
            wand.farbeAendern("schwarz");
            fenster.farbeAendern("weiss");
            dach.farbeAendern("schwarz");
            sonne.farbeAendern("schwarz");
            zweiteSonne.farbeAendern("schwarz");
        }
    }

    /**
     * ndere die Darstellung in Farbe.
     */
    public void inFarbeAendern()
    {
        if(wand != null)   // nur wenn schon gezeichnet wurde ...
        {
            wand.farbeAendern("rot");
            fenster.farbeAendern("schwarz");
            dach.farbeAendern("gruen");
            sonne.farbeAendern("gelb");
            zweiteSonne.farbeAendern("rot");
        }
    }
    
    /**
     * Lasse die erste Sonne untergehen
     */
    public void sonnenuntergang()
    {
        sonne.langsamVertikalBewegen(300);
    }    
    
     /**
     * Lasse beide Sonnen parallel untergehen
     */
    public void alleSonnenGehenUnter()
    {
        int i;
        for (i=0; i<300; i++)
        {
           sonne.langsamVertikalBewegen(1);
           zweiteSonne.langsamVertikalBewegen(1);
        }   
    } 
    
    
    /**
     * Mache im Haus das Licht aus
     */
    public void lichtAus()
    {
      fenster.farbeAendern("schwarz");
    }   
    
    /**
     * Mache im Haus das Licht an
     */
    public void lichtAn()
    {
      fenster.farbeAendern("gelb");
    }   
    
}
